# Design-and-modeling-of-adaptive-IIR-filtering-systems-using-a-weighted-sum-variable-length-PSO

In this repository, all the data of the article called "Design and modeling of adaptive IIR filtering systems using a weighted sum - variable length particle swarm optimization" has been attached.

Data including specifications, access links, all source code of implementations and simulations are provided along with all extracted results.

Note: Given the volume of implementations and outputs, the source codes are reported based on Example 4 of the article, which can be easily extended to other examples.
If used, the article link should be cited below.

A. Mohammadi, S. H. Zahiri, S. M. Razavi, and P. N. Suganthan, “Design and modeling of adaptive IIR filtering systems using a weighted sum-variable length particle swarm optimization,” Appl. Soft Comput., vol. 109, p. 107529, 2021. DOI: https://doi.org/10.1016/j.asoc.2021.107529

Some information of this research is as follows:

Highlights:

• Simultaneous modeling the dynamic order IIR system and its corresponding coefficients.

• A novel and dynamic version of variable-length PSO as an effective adaptive algorithm.

• Providing and applying an intelligent and effective weighted sum objective function.

• The proposed WS-VLPSO used to design optimal IIR filters and solving coverage problems.

• A new criterion called OMI to verify the intelligent minimization of filter orders.

Abstract:

The use of optimization algorithms for designing Infinite Impulse Response (IIR) filters has been considered in many studies. The concern in this area is the multimodal error surface of such filters and their fitting with filter coefficients. The order of the modeled system has a direct effect on the number of coefficients, complexities of the error surface, and the filter’s stability. This paper proposes an efficient approach based on a variable length particle swarm optimization algorithm with a weighted sum fitness function (WS-VLPSO). The proposed WS-VLPSO is utilized as an effective adaptive algorithm for designing optimal IIR filters. The approach is based on the inclusion of the order as a discrete variable in the particle vector, which is done with the goal of intelligent minimizing of order and thereby reducing the design complexity of IIR filters. To ensure the optimality of the systems, the objective function is considered as a weighted sum. Also, a new criterion called Optimum Modeling Indicator (OMI) is introduced, a measure to determine the percentage reduction of order and the success rate of the proposed approach. The proposed algorithm is also applied for solving the sensor coverage problem as another real-world variable length engineering optimization application. Evaluation of simulation results, with Monte-Carlo simulation, indicates the acceptable improvement of identified structures and the significant performance of the proposed approaches. Note that the source codes of the paper will be publicly available at https://github.com/ali-ece.


